#! /usr/bin/perl -I /home/studio/lib
######################################################################
#
#	LOXNvg
#
#	o͂ĺAR[hSJISContent-Lengthwb_
#
#	@project	: jRplDX
#	@author		: f.takahara
#	@version	: 1.00
#	@charset	: SJIS
#	@date		: ----/--/-- --:--:--
#
######################################################################

#RQLCu
require 'COMMON.pl';

use CGI;							#CGIW[
use CGI::Carp qw(fatalsToBrowser);	#fobOpW[
use NisDB;							#NisDBCu
use NISM;							#Nisėp

#NX̐
my $cgi = new CGI;
my $db = new NisDB( "marldb","rql" );
my $nism = new NISM;

#----------------------------------------------------------
#	ϐ
#----------------------------------------------------------
my $table_member = "member_list";
my $table_name = "npdx";
my $now_carrier = "i";

#----------------------------------------------------------
#	NG擾
#----------------------------------------------------------
my $uid  = $cgi->param('uid');
my $mode  = $cgi->param('mode');

#fobOpГUIDɕύX(IP)
if( $ENV{'REMOTE_ADDR'} eq $COMMON::nis_ip ) {
	
	$uid = "01eQQwojPHaj";
	
	#Ǘy[W
	&Admin()		if( $mode eq "admin" );
	&Delete()		if( $mode eq "delete" );
	&TestRegist()	if( $mode eq "TestRegist" );
	
}

#LOXV
&Main();
exit;


###########################################################
#
#	LO{
#	\Xe[Wԍ擾ÃXe[W
#	P`POʂ̃[U[̖OƃXRAԂ
#
###########################################################
sub Main() {
	
	#낢`FbN(Ђꍇ̓XNvgI)
	&CheckAll( $uid );
	
	&Regist();
	
	#LOo
	foreach( 0 .. 7 ) {
		&OutputRanking( $_ );
	}
	$nism->OUTPUT_I();
}



sub OutputRanking( $ ) {
	
	my( $stage ) = @_;
	$stage = "s". $stage;
	
	#LỎʂ܂ŕ\邩
	my $limit = 9;
	
	#DB $limit ʂ܂ł̃f[^o
	$sql = qq{
		SELECT T2.name, T1.$stage 
		FROM $table_name T1, $table_member T2 
		WHERE T2.uid=substr(T1.uid,3) 
		  AND T2.name<>'' 
		  AND T1.$stage<>'-1' 
		  AND (T2.entry1=1 OR T2.entry3=1) 
		ORDER BY T1.$stage DESC 
		LIMIT $limit 
	};
	
	#$nism->PRINT( $sql );
	$db->exec($sql);
	
	#1ʁ`$limitʂ܂ł̃f[^o͂
	foreach( 0 .. $limit ) {
		
		#lo
		my( $name, $score ) = $db->read($_);
		
		#SJISϊ
		COMMON::Convert(\$name,'sjis');
		
		if( $score eq "" ) {
			$score = 0;
		}
		
		#obt@ɃLOf[^o
		$nism->PRINT2( "$name,$score," );
	}
}



sub CheckAll( $ ) {
	
	#擾
	my( $uid ) = @_;
	
	#H
	if( &COMMON::isMember( $uid ) == 0 ) {
		#
		$nism->PRINT2( "1" );
		$nism->OUTPUT_I();
	}
	
	#LOΉ@H
	if( isRankUnsupportModel() == 1 ) {
		#Ή@
		$nism->PRINT2( "2" );
		$nism->OUTPUT_I();
	}
	
	#[U[l[o^
	if( &COMMON::getUserName( $uid ) eq "" ) {
		#o^
		$nism->PRINT2( "3" );
		$nism->OUTPUT_I();
	}
	
	return "OK";
}

###########################################################
#
#	UID̏ʂ擾ĕԂ
#	AOȂꍇ "-" Ԃ
#
###########################################################
sub GetRank() {
	
	#擾
	my ( $uid, $my_score, $stage ) = @_;
	my $month = $nism->GetYM();
	
	#SQL̐
	my $sql = qq{
		SELECT T1.$stage 
		FROM $table_name T1, $table_member T2 
		WHERE T2.uid=substr(T1.uid,3) 
		  AND T2.name<>'' 
		  AND T1.$stage>='$my_score' 
		  AND T1.month='$month' 
		  AND (T2.entry1=1 OR T2.entry3=1) 
		ORDER BY T1.$stage ASC
	};
	
	#s
	$db->exec($sql);
	#$nism->PRINT2( $sql ."<hr>" );
	
	#ʂ擾
	my $result = $db->getRows();
	$result = '-' if( $result == 0 );
	
	return $result;
}

###########################################################
#
#	UID̃XRAԂ
#	f[^Ȃꍇ"o^"Ԃ
#
###########################################################
sub GetScore( $ ) {
	
	my ( $uid, $stage ) = @_;
	
	$db->exec( "SELECT $stage FROM $table_name WHERE uid='$uid' AND month='". $nism->GetYM() ."'" );
	my( $my_score ) = $db->read();
	$my_score = "o^" if( $db->getRows() == 0 );
	
	return $my_score;
	
}


###########################################################
#
#	LOΉ@킩`FbN
#
###########################################################
sub isRankUnsupportModel()
{
	$model = &COMMON::getModel() if( $model eq '' );
	
	#Ή@ꗗɂ@̓NȂ
	if( &COMMON::isCorrespondFromFile( "RankUnsupportModel.txt", $model ) ) {
		#Ή@
		return 1;
	}
	
	#Ή@
	return 0;
}

#==========================================================#
#	KDDIpeXgID̊mF
#
#	testtH_UIDƓt@C̃f[^ꍇ
#	eXgp[ƂB
#==========================================================#
sub isTestMode() {
	
	#KDDIؗp[ǂ`FbN
	if( open( FILE, "test/$uid" ) ) {
		close( FILE );
		
		#fobO[h
		return 1;
	}
	return 0;
}



###########################################################
#
#	LOo^
#	Xe[WP`W܂ł̃^Co^A
#	Xe[WP`W܂ł̎̏ʂԂ
#
###########################################################
sub Regist() {
	
	#N擾
	$month = $nism->GetYM();
	
	#NGXRA擾( 0 ` 7 )
	foreach( 0 .. 7 ) {
		$score[$_] = $cgi->param( "s". $_ );
		
		#Ȃ炩̗RŃXRÂƂ͂Oɂ
		if( $score[$_] eq "" || $score[$_] < 0 ) {
			$score[$_] = "0";
		}
	}
	
	my $sql = "";
	
	#f[^o^Ă邩`FbN
	if( &GetScore( $uid, "s0" ) eq "o^" ) {
		
		#o^̂ŐVKo^
		$sql = qq{INSERT INTO $table_name VALUES( '$uid', '$now_carrier', '$month', };
		foreach( 0 .. 7 ) {
			#R}hɒǉ
			$sql .= qq{$score[$_], };
		}
		
		#o^
		$sql .= "'". $nism->GetTimeAll() . "')";
		
		#R}hs
		$db->exec( $sql );
		#$nism->PRINT2( $sql );
		
	} else {
		
		#ɓo^Ă̂ōXV
		$sql = qq{UPDATE $table_name SET };
		foreach( 0 .. 7 ) {
			$sql .= qq{s$_=$score[$_], };
		}
		
		#o^̔N
		$sql .= "month='". $nism->GetYM() . "', ";
		
		#o^
		$sql .= "time='". $nism->GetTimeAll() . "' ";
		
		#
		$sql .= "WHERE uid='$uid'";
		
		#R}hs
		$db->exec( $sql );
		#$nism->PRINT2( $sql );
	}
	
	#߂lwb_
	$nism->PRINT2( "0," );
	
	#o^orXV̏ʂԂ
	foreach( 0 .. 7 ) {
		#̃^C擾
		$my_rank[$_] = &GetRank( $uid, $score[$_], "s$_" );
		if( $my_rank[$_] eq "-" ) {
			$my_rank[$_] = "0";
		}
		
		$nism->PRINT2( "$my_rank[$_]," );
	}
}




sub Admin() {
	
	#擾
	my( $mes ) = @_;
	
	OutputHeader();
	
	#e[uo
	$nism->PRINT( qq{
		y npdxAdmin z<br><hr>
	} );
	
	#bZ[WΕ\
	if( $mes ne "" ) {
		$nism->PRINT( qq{InfoF<font color="#ff5555">$mes</font><br><hr>} );
	}
	
	#eXgf[^o^tH[o͂
	&OutputTestRegist();
	
	$nism->PRINT( qq{
		o^f[^( <font color="#ff5555">zḾA[U[̎ۂ̃f[^\\܂B폜ۂɂ͒ӂĂ</font> )<br>
		<table border="1" cellspacing="0" cellpadding="3" bordercolorlight="gray" bordercolordark="white">
		<tr bgcolor="#dfdfdf"><td>O</td><td>uid</td><td>month</td>
	} );
	
	#e[ủso
	foreach( 0 .. 7 ) { $nism->PRINT( qq{<td>s$_</td>} ); }
	
	#폜{s
	$nism->PRINT( qq{<td>폜</td></tr>} );
	
	#R}hs
	$db->exec( "SELECT uid,month,s0,s1,s2,s3,s4,s5,s6,s7 FROM $table_name WHERE carrier='$now_carrier' ORDER BY s0 ASC" );
	
	#f[^܂킷
	foreach( 0 .. $db->getRows()-1 ) {
		
		#sJ
		$nism->PRINT( qq{
			<tr>
			<form method="POST" action="rank.cgi">
			<input type="hidden" name="mode" value="delete">
		} );
		
		#f[^擾
		my( @data ) = $db->read($_);
		
		#UID疼O擾A\
		$name = &COMMON::getUserName( $data[0] );
		&COMMON::Convert( \$name, "sjis" );
		$nism->PRINT( qq{<td>$name</td>} );
		
		#\
		foreach( @data ) { $nism->PRINT( qq{<td>$_</td>} ); }
		
		#폜{s
		$nism->PRINT( qq{
			<td>
			<input type="hidden" name="uid" value="$data[0]">
			<input type="submit" value="폜">
			<input type="checkbox" name="chk" value="1">
			</td>
			</tr>
		} );
		
	}
	$nism->PRINT( qq{</table>} );
	
	#if( &COMMON::getUserName($uid) eq '' ) {
	#	$nism->PRINT( "3,0,0,0,0,0" );
	#	$nism->OUTPUT_I();
	#}
	
	$nism->OUTPUT_I();
}


sub Delete() {
	
	my $uid = $cgi->param( "uid" );
	
	if( $cgi->param( "chk" ) eq "" ) {
		&Admin( "폜mF`FbNĂ܂B" );
	}
	
	$db->exec( "DELETE FROM $table_name WHERE uid='$uid'" );
	&Admin( "폜܂B" );
}


sub OutputTestRegist() {
	
	$nism->PRINT( qq{
		o^URL<br>
		<table width="100%"><tr><td nowrap>http://studio.nippon1.co.jp/i/appli/npdx/app/rank.cgi?uid=NULLGWDOCOMO&mode=regist&s0=10&s1=10&s2=10&s3=10&s4=10&s5=10&s6=01&s7=10</td></tr></table>
		<br>
		
		LOf[^擾URL<br>
		<table width="100%"><tr><td nowrap>http://studio.nippon1.co.jp/i/appli/npdx/app/rank.cgi?uid=NULLGWDOCOMO&s=0</td></tr></table>
		<br>
		
		f[^o^( eXgpUIDœo^邱Ƃł܂ )<br>
		<table border="1" cellspacing="0" cellpadding="3" bordercolorlight="gray" bordercolordark="white">
		<tr bgcolor="#dfdfdf"><td>uid</td>
	} );
	
	foreach( 0 .. 7 ) { $nism->PRINT( qq{<td>s$_</td>} ); }
	
	$nism->PRINT( qq{
		</tr>
		
		<form method="POST" action="rank.cgi">
		<input type="hidden" name="mode" value="TestRegist">
		<input type="hidden" name="uid" value="$uid">
		
		<tr><td>$uid</td>
	} );
	
	foreach( 0 .. 7 ) {
		$nism->PRINT( qq{
			<td><input type="textbox" name="s$_" value="100" size="5"></td>
		} );
	}
	
	
	$nism->PRINT( qq{
		</tr><tr><td colspan="12"><input type="submit" value="o^"></td></tr>
		</form></table>
		<br><hr><br>
	} );
	
}


sub TestRegist() {
	
	my $uid = $cgi->param( "uid" );
	my $month = $nism->GetYM();			#N擾
	
	#NGXRA擾( 0 ` 7 )
	foreach( 0 .. 7 ) {
		$score[$_] = $cgi->param( "s". $_ );
		if( $score[$_] eq "" || $score[$_] eq "0" ) {
			$score[$_] = "-1";
		}
	}
	
	#f[^o^Ă邩`FbN
	#o^̂ŐVKo^
	my $sql = "";
		
	#R}h쐬
	$sql = qq{INSERT INTO $table_name VALUES( '$uid', '$now_carrier', '$month', };
	foreach( 0 .. 7 ) {
		#R}hɒǉ
		$sql .= qq{$score[$_], };
	}
	
	#o^
	$sql .= "'". $nism->GetTimeAll() . "')";
	
	#R}hs
	$db->exec( $sql );
	
	&Admin( "eXgf[^o^܂B" );
}


##############################################################################################
#
#	
#
##############################################################################################
sub OutputHeader() {
	
	$nism->PRINT( qq{
	<html><head><title>npdx</title>
	
	<style>
	<!--
	a:hover {
		color: white;
		background-color: #ff6666;
	}
	
	table { font-size: 10pt; }
	input { font-size: 10pt; }
	-->
	</style>
	</head>
	} );
	
	$nism->PRINT( qq{<body bgcolor="#f0f0f0" text="#444488" link="#6666ff" alink="#6666ff" vlink="#6666ff" style="font-size:10pt">} );
}

