#! /usr/bin/perl -I /home/studio/lib
######################################################################
#
#	LOXNvg
#
#	@project	: jRplDX(DoCoMo)
#	@charset	: SJIS
#	
#	yver 1.02z2007/8/28 23:29:07 f.takahara
#	ʂ߂ۂɓ_Ɠo^ԂŃ\[gȂ悤
#
#	yver 1.01z2007/8/2 09:32:04 f.takahara
#	ԃLOɑΉ
#
######################################################################

#RQLCu
require 'COMMON.pl';
require 'NPDX.pl';

use CGI;							#CGIW[
use CGI::Carp qw(fatalsToBrowser);	#fobOpW[
use NisDB;							#NisDBCu
use NISM;							#Nisėp

#NX̐
my $cgi = new CGI;
my $db = new NisDB( "marldb","rql" );
my $nism = new NISM;

#----------------------------------------------------------
#	ϐ
#----------------------------------------------------------
my $table_member = "member_list";
my $table_name = "npdx";
my $now_carrier = "i";

#----------------------------------------------------------
#	NG擾
#----------------------------------------------------------
my $uid  = $cgi->param('uid');
my $mode  = $cgi->param('mode');

#fobOpГUIDɕύX(IP)
if( $ENV{'REMOTE_ADDR'} eq $COMMON::nis_ip || $ENV{'REMOTE_ADDR'} eq "$COMMON::osaka_ip" ) {
	
	$uid = "01eQQwojPHaj";
	
	#Ǘy[W
	&Admin()							if( $mode eq "admin" );
	&NPDX::Delete()						if( $mode eq "delete" );
	&NPDX::TestRegist( $now_carrier )	if( $mode eq "TestRegist" );
}

&NPDX::Main( $uid, $now_carrier );
exit;





sub OutputRanking( $ ) {
	
	my( $stage ) = @_;
	$stage = "s". $stage;
	
	#LỎʂ܂ŕ\邩
	my $limit = 10;
	
	my $month = $nism->GetYM();
	
	#DB $limit ʂ܂ł̃f[^o
	$sql = qq{
		SELECT T2.name, T1.$stage 
		FROM $table_name T1, $table_member T2 
		WHERE T2.uid=substr(T1.uid,3) 
		  AND T2.name<>'' 
		  AND T1.$stage<>'-1' 
		  AND (T2.entry1=1 OR T2.entry3=1) 
		  AND T1.month='$month' 
		  AND T1.carrier='$now_carrier' 
		ORDER BY T1.$stage DESC, T1.time ASC 
		LIMIT $limit 
	};
	
	#$nism->PRINT( $sql );
	$db->exec($sql);
	
	#1ʁ`$limitʂ܂ł̃f[^o͂
	foreach( 0 .. $limit-1 ) {
		
		#lo
		my( $name, $score ) = $db->read($_);
		
		#SJISϊ
		COMMON::Convert(\$name,'sjis');
		
		if( $score eq "" ) {
			$score = 0;
		}
		
		#obt@ɃLOf[^o
		$nism->PRINT2( "$name,$score," );
	}
}



sub CheckAll( $ ) {
	
	#擾
	my( $uid ) = @_;
	
	#H
	if( &COMMON::isMember( $uid ) == 0 ) {
		#
		$nism->PRINT2( "1" );
		$nism->OUTPUT_I();
	}
	
	#LOΉ@H
	if( isRankUnsupportModel() == 1 ) {
		#Ή@
		$nism->PRINT2( "2" );
		$nism->OUTPUT_I();
	}
	
	#[U[l[o^
	if( &COMMON::getUserName( $uid ) eq "" ) {
		#o^
		$nism->PRINT2( "3" );
		$nism->OUTPUT_I();
	}
	
	return "OK";
}

###########################################################
#
#	UID̏ʂ擾ĕԂ
#	AOȂꍇ "-" Ԃ
#
###########################################################
sub GetRank() {
	
	#擾
	my ( $uid, $my_score, $stage ) = @_;
	my $month = $nism->GetYM();
	
	#SQL̐
	my $sql = qq{
		SELECT T1.$stage 
		FROM $table_name T1, $table_member T2 
		WHERE T2.uid=substr(T1.uid,3) 
		  AND T2.name<>'' 
		  AND T1.$stage>='$my_score' 
		  AND T1.month='$month' 
		  AND (T2.entry1=1 OR T2.entry3=1) 
		  AND T1.carrier='$now_carrier' 
		ORDER BY T1.$stage DESC, T1.time ASC 
	};
	
	#s
	$db->exec($sql);
	#$nism->PRINT2( $sql ."<hr>" );
	
	#ʂ擾
	return $db->getRows();
}




###########################################################
#
#	LOΉ@킩`FbN
#
###########################################################
sub isRankUnsupportModel()
{
	$model = &COMMON::getModel() if( $model eq '' );
	
	#Ή@ꗗɂ@̓NȂ
	if( &COMMON::isCorrespondFromFile( "RankUnsupportModel.txt", $model ) ) {
		#Ή@
		return 1;
	}
	
	#Ή@
	return 0;
}




sub Admin() {
	
	#擾
	my( $mes ) = @_;
	
	&NPDX::OutputHeader();
	
	#e[uo
	$nism->PRINT( qq{
		y npdxAdmin z<br><hr>
	} );
	
	#bZ[WΕ\
	if( $mes ne "" ) {
		$nism->PRINT( qq{InfoF<font color="#ff5555">$mes</font><br><hr>} );
	}
	
	#eXgf[^o^tH[o͂
	&NPDX::OutputTestRegist( $uid );
	
	$nism->PRINT( qq{
		o^f[^( <font color="#ff5555">zḾA[U[̎ۂ̃f[^\\܂B폜ۂɂ͒ӂĂ</font> )<br>
		<table border="1" cellspacing="0" cellpadding="3" bordercolorlight="gray" bordercolordark="white">
		<tr bgcolor="#dfdfdf"><td>O</td><td>uid</td><td>month</td>
	} );
	
	#e[ủso
	foreach( 0 .. 7 ) { $nism->PRINT( qq{<td>s$_</td>} ); }
	
	#폜{s
	$nism->PRINT( qq{<td>폜</td></tr>} );
	
	#R}hs
	$db->exec( "SELECT uid,month,s0,s1,s2,s3,s4,s5,s6,s7 FROM $table_name WHERE carrier='$now_carrier' ORDER BY s0 DESC, time ASC" );
	
	
	my $db2 = new NisDB( "marldb","rql" );
	
	#f[^܂킷
	foreach( 0 .. $db->getRows()-1 ) {
		
		#sJ
		$nism->PRINT( qq{
			<tr>
			<form method="POST" action="rank.cgi">
			<input type="hidden" name="mode" value="delete">
		} );
		
		#f[^擾
		my( @data ) = $db->read($_);
		
		#UID疼O擾A\
		$db2->exec( "SELECT name FROM member_list WHERE uid='". substr( $data[0],2 ) ."'" );
		$name = $db2->read();
		
		&COMMON::Convert( \$name, "sjis" );
		$nism->PRINT( qq{<td>$name</td>} );
		
		#\
		foreach( @data ) { $nism->PRINT( qq{<td>$_</td>} ); }
		
		#폜{s
		$nism->PRINT( qq{
			<td>
			<input type="hidden" name="uid" value="$data[0]">
			<input type="submit" value="폜">
			<input type="checkbox" name="chk" value="1">
			</td>
			</tr>
		} );
		
	}
	$nism->PRINT( qq{</table>} );
	
	#if( &COMMON::getUserName($uid) eq '' ) {
	#	$nism->PRINT( "3,0,0,0,0,0" );
	#	$nism->OUTPUT_I();
	#}
	
	$nism->OUTPUT_I();
}
